// C Source File
// Created 6/3/2012; 2:16:41 PM
// Decthyth General 68k Libraries
#include <tigcclib.h>
//#define RETURN_VALUE n
#define VERSION_NUM 0.21
FILE* interface[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
void DlgError(const char* msg)
{
	DlgMessage("Error",msg,BT_CANCEL,BT_NONE);
}
void WriteToNInt(long n)
{
	push_longint(n);
	VarStore(SYMSTR("n"),STOF_ESI,0,top_estack);
}
void WriteToNFloat(float n)
{
	push_Float(n);
	VarStore(SYMSTR("n"),STOF_ESI,0,top_estack);
}
void WriteToNString(char* n)
{
	push_zstr(n);
	VarStore(SYMSTR("n"),STOF_ESI,0,top_estack);
}
void WriteToNBool(int n)
{
	push_quantum(0x2B+!!n);
	VarStore(SYMSTR("n"),STOF_ESI,0,top_estack);
}

short show_picvar (SYM_STR SymName, short x, short y, short Attr)
{
  SYM_ENTRY *sym_entry = SymFindPtr (SymName, 0);
  if (!sym_entry) return FALSE;
  if (peek (HToESI (sym_entry->handle)) != PIC_TAG) return FALSE;
  BitmapPut (x, y, HeapDeref (sym_entry->handle) + 2, ScrRect, Attr);
  return TRUE;
}
// Main Function
/*
NOTE: When I say that a function returns a value,
I mean that the value is stored to n.
*/
void _main(void)
{
	int mode;
	unsigned char a;
	const SCR_RECT* all=&(SCR_RECT){{0,0,239,127}};
	ESI argptr=top_estack;
	a=GetArgType(argptr);
	if (a!=POSINT_TAG)
	{
		DlgError("First arg must be + int");
		return;
	}
	mode=GetIntArg(argptr);
	int x,y,attr,s,os,c,i,ox,oy;
	long xx,yy;
	SYM_STR name;
	WIN_RECT temp;
	SCR_RECT temp2;
	ESI temp3;
	INT_HANDLER I1,I5;
	FILE* fio;
	char* temp4;
	switch (mode)
	{
		case 0:
		WriteToNFloat(VERSION_NUM);
		break;
		case 1:
		clrscr();
		break;
		//
		//Pictures
		//
		case 2:
		a=GetArgType(argptr);
		if (a!=STR_TAG)
		{
			DlgError("Arg 2 must be string");
			return;
		}
		name=GetSymstrArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 3 must be + int");
			return;
		}
		x=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 4 must be + int");
			return;
		}
		y=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 5 must be + int");
			return;
		}
		attr=GetIntArg(argptr);
		//*A_REVERSE, *A_NORMAL, *A_XOR, *A_SHADED, *A_REPLACE, *A_OR, *A_AND, A_THICK1, A_SHADE_V, A_SHADE_H, A_SHADE_NS, A_SHADE_PS
		if (attr>=7)
		{
			DlgError("Wrong attribute");
			return;
		}
		if (!show_picvar(name,x,y,attr))
		{
			DlgError("Pic does not exist");
		}
		break;
		//
		//Lines
		//
		case 3:
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 2 must be + int");
			return;
		}
		temp.x0=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 3 must be + int");
			return;
		}
		temp.y0=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 4 must be + int");
			return;
		}
		temp.x1=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 5 must be + int");
			return;
		}
		temp.y1=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 5 must be + int");
			return;
		}
		attr=GetIntArg(argptr);
		//*A_REVERSE, *A_NORMAL, *A_XOR, A_SHADED, A_REPLACE, A_OR, A_AND, *A_THICK1, *A_SHADE_V, *A_SHADE_H, *A_SHADE_NS, *A_SHADE_PS
		if (attr>2&&attr<6)
		{
			DlgError("Wrong attribute");
			return;
		}
		DrawClipLine(&temp,all,attr);
		break;
		//
		//Rectangles
		//
		case 4:
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 2 must be + int");
			return;
		}
		temp.x0=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 3 must be + int");
			return;
		}
		temp.y0=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 4 must be + int");
			return;
		}
		temp.x1=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 5 must be + int");
			return;
		}
		temp.y1=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 6 must be + int");
			return;
		}
		attr=GetIntArg(argptr);
		DrawClipRect(&temp,all,attr);
		break;
		//
		case 5:
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 2 must be + int");
			return;
		}
		temp2.xy.x0=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 3 must be + int");
			return;
		}
		temp2.xy.y0=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 4 must be + int");
			return;
		}
		temp2.xy.x1=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 5 must be + int");
			return;
		}
		temp2.xy.y1=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 6 must be + int");
			return;
		}
		attr=GetIntArg(argptr);
		if (attr>3)
		{
			DlgError("Wrong attribute");
			return;
		}
		ScrRectFill(&temp2,all,attr);
		break;
		//
		//Text
		//
		case 6:
		a=GetArgType(argptr);
		if (a!=STR_TAG)
		{
			DlgError("Arg 2 must be string");
			return;
		}
		name=GetStrnArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 3 must be + int");
			return;
		}
		x=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 4 must be + int");
			return;
		}
		y=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 5 must be + int");
			return;
		}
		attr=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 6 must be + int");
			return;
		}
		s=GetIntArg(argptr);
		//*A_REVERSE, *A_NORMAL, *A_XOR, *A_SHADED, *A_REPLACE
		if (attr>=5)
		{
			DlgError("Wrong attribute");
			return;
		}
		if (s<0||s>2)
		{
			DlgError("Invalid size");
			return;
		}
		os=FontSetSys(s);
		if (((x+DrawStrWidth(name,s))>239)||((y+4+2*s)>127))
		{
			DlgError("Out of bounds");
			return;
		}
		DrawStr(x,y,name,attr);
		FontSetSys(os);
		break;
		
		case 7:
		a=GetArgType(argptr);
		if (a!=STR_TAG)
		{
			DlgError("Arg 2 must be string");
			return;
		}
		name=GetStrnArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 3 must be + int");
			return;
		}
		x=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 4 must be + int");
			return;
		}
		y=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 5 must be + int");
			return;
		}
		attr=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 6 must be + int");
			return;
		}
		s=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 7 must be + int");
			return;
		}
		c=GetIntArg(argptr);
		//*A_REVERSE, *A_NORMAL, *A_XOR, *A_SHADED, *A_REPLACE
		if (attr>=5)
		{
			DlgError("Wrong attribute");
			return;
		}
		if (s<1||s>2)
		{
			DlgError("Invalid size");
			return;
		}
		if ((x+c)>239)
		{
			DlgError("Out of bounds");
			return;
		}
		os=FontSetSys(s);
		ox=x;
		oy=y;
		for(i=0;i<strlen(name);i++)
		{
			DrawChar(x,y,name[i],attr);
			x+=4+2*s;
			if ((ox+c)<x)
			{
				x=ox;
				y+=6+2*s;
			}
			if (x>239)
			{
				DlgError("Out of bounds");
				return;
			}
		}
		FontSetSys(os);
		break;
		case 8:
		a=GetArgType(argptr);
		if (a!=STR_TAG)
		{
			DlgError("Arg 2 must be string");
			return;
		}
		name=GetStrnArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 3 must be + int");
			return;
		}
		x=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 4 must be + int");
			return;
		}
		y=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 5 must be + int");
			return;
		}
		s=GetIntArg(argptr);
		os=FontSetSys(s);
		MoveTo(x,y);
		puts(name);
		FontSetSys(os);
		break;
		case 9:
		WriteToNInt(ngetchx());
		break;
		case 10:
		WriteToNInt(kbhit()?ngetchx():0);
		break;
		case 11:
		case 12:
		OSdequeue(&x,kbd_queue());
		if (mode==12) x&=~0x0800;
		WriteToNInt(x);
		break;
		case 13:
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 2 must be + int");
			return;
		}
		y=GetIntArg(argptr);
		I1=GetIntVec(AUTO_INT_1);
		I5=GetIntVec(AUTO_INT_5);
		x=_rowread(y);
		SetIntVec(AUTO_INT_1,I1);
		SetIntVec(AUTO_INT_5,I5);
		WriteToNInt(x);
		break;
		case 14:
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 2 must be + int");
			return;
		}
		x=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 3 must be + int");
			return;
		}
		y=GetIntArg(argptr);
		I1=GetIntVec(AUTO_INT_1);
		I5=GetIntVec(AUTO_INT_5);
		s=_keytest(x,y);
		SetIntVec(AUTO_INT_1,I1);
		SetIntVec(AUTO_INT_5,I5);
		WriteToNBool(s);
		break;
		case 15:
		WriteToNInt(getchar());
		break;
		case 16:
		a=GetArgType(argptr);
		if (a!=STR_TAG)
		{
			DlgError("Arg 2 must be string");
			return;
		}
		const char* f=GetStrnArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 3 must be + int");
			return;
		}
		x=GetIntArg(argptr);
		char* b=NULL;
		if (!(b=malloc(x)))
		{
			DlgError("DMA failed; not enough memory.");
			WriteToNString("phail");
			return;
		}
		puts(f);
		getsn(b,x);
		WriteToNString(b);
		free(b);
		break;
		case 17:
		a=GetArgType(argptr);
		if (a!=STR_TAG)
		{
			DlgError("Arg 2 must be string");
			return;
		}
		const char* f2=GetStrnArg(argptr);
		char* b2=NULL;
		if (!(b2=malloc(20)))
		{
			DlgError("DMA failed; not enough memory.");
			WriteToNString("phail");
			return;
		}
		puts(f2);
		getsn(b2,20);
		WriteToNFloat(atof(b2));
		free(b2);
		break;
		case 18:
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 2 must be + int");
			return;
		}
		x=GetIntArg(argptr);
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 3 must be + int");
			return;
		}
		y=GetIntArg(argptr);
		MoveTo(x,y);
		break;
		case 19:
		a=GetArgType(argptr);
		if (a!=LIST_TAG)
		{
			DlgError("Arg 2 must be list");
			return;
		}
		temp3=argptr-1;
		while (!(*temp3==TRUE_TAG||*temp3==END_TAG))
		{
			temp3=next_expression_index(temp3);
		}
		WriteToNBool(*temp3==TRUE_TAG);
		break;
		case 20:
		a=GetArgType(argptr);
		if (a!=LIST_TAG)
		{
			DlgError("Arg 2 must be list");
			return;
		}
		temp3=argptr-1;
		while (!(*temp3==FALSE_TAG||*temp3==END_TAG))
		{
			temp3=next_expression_index(temp3);
		}
		WriteToNBool(*temp3!=FALSE_TAG);
		break;
		case 21:
		a=GetArgType(argptr);
		if (a!=LIST_TAG)
		{
			DlgError("Arg 2 must be list");
			return;
		}
		temp3=argptr-1;
		x=1;
		while (!(*temp3==TRUE_TAG||*temp3==END_TAG))
		{
			temp3=next_expression_index(temp3);
			x++;
		}
		WriteToNInt(x*(*temp3==TRUE_TAG));
		break;
		case 22:
		a=GetArgType(argptr);
		if (a!=POSINT_TAG&&a!=NEGINT_TAG)
		{
			DlgError("Arg 2 must be int");
			return;
		}
		xx=GetIntArg(argptr);
		if (a==NEGINT_TAG) xx*=-1;
		WriteToNInt(peekIO(xx));
		break;
		case 23:
		a=GetArgType(argptr);
		if (a!=POSINT_TAG&&a!=NEGINT_TAG)
		{
			DlgError("Arg 2 must be int");
			return;
		}
		xx=GetIntArg(argptr);
		if (a==NEGINT_TAG) xx*=-1;
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 3 must be + int");
			return;
		}
		y=GetIntArg(argptr);
		pokeIO(xx,y);
		break;
		case 24:
		a=GetArgType(argptr);
		if (a!=STR_TAG)
		{
			DlgError("Arg 2 must be string");
			return;
		}
		const char* f3=GetStrnArg(argptr);
		a=GetArgType(argptr);
		if (a!=STR_TAG)
		{
			DlgError("Arg 3 must be string");
			return;
		}
		const char* f4=GetStrnArg(argptr);
		a=GetArgType(argptr);
		for (x=0;x<=16;x++)
		{
			if (!interface[x]) break;
		}
		if (x!=16)
		{
			interface[x]=fopen(f3,f4);
		}
		WriteToNInt(x);
		break;
		case 25:
		a=GetArgType(argptr);
		if (a!=POSINT_TAG)
		{
			DlgError("Arg 2 must be int");
			return;
		}
		x=GetIntArg(argptr);
		if (x<0||x>=16)
		{
			DlgError("Arg 2 out of range");
			return;
		}
		fclose(interface[x]);
		interface[x]=NULL;
		break;
	}
}
